Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 8409)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 8410)
@@ -102,4 +102,5 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="VariableDuplicator.cs" />
   </ItemGroup>
   <ItemGroup>
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs	(revision 8409)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs	(revision 8410)
@@ -26,6 +26,8 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
+using HeuristicLab.Optimization.Operators;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -58,4 +60,13 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["QualityAfterMutation"]; }
     }
+    public ILookupParameter<Permutation> PermutationBeforeMutationParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PermutationBeforeMutation"]; }
+    }
+    public ILookupParameter<Permutation> PermutationAfterMutationParameter {
+      get { return (ILookupParameter<Permutation>)Parameters["PermutationAfterMutation"]; }
+    }
+    public IValueParameter<SingleObjectiveSolutionSimilarityCalculator> SimilarityCalculatorParameter {
+      get { return (IValueParameter<SingleObjectiveSolutionSimilarityCalculator>)Parameters["SimilarityCalculator"]; }
+    }
     #endregion
 
@@ -66,6 +77,6 @@
     #endregion
 
-    ScatterPlot plot;
-    DataRow dtRow;
+    ScatterPlot plot, diversityPlot;
+    DataRow dtRow, dtDivRow;
     int cnt = 0;
 
@@ -83,4 +94,12 @@
       Parameters.Add(new LookupParameter<DoubleValue>("QualityAfterMutation", "The evaluated quality of the child solution."));
       QualityAfterMutationParameter.ActualName = "TSPTourLengthM";
+
+      Parameters.Add(new LookupParameter<Permutation>("PermutationBeforeMutation"));
+      QualityAfterMutationParameter.ActualName = "TSPTourClone";
+
+      Parameters.Add(new LookupParameter<Permutation>("PermutationAfterMutation"));
+      QualityAfterMutationParameter.ActualName = "TSPTour";
+
+      Parameters.Add(new ValueParameter<SingleObjectiveSolutionSimilarityCalculator>("SimilarityCalculator"));
     }
 
@@ -141,4 +160,10 @@
       plot.VisualProperties.YAxisTitle = "Absolut Quality Difference";
     }
+
+    private void InitializeDiversityPlot() {
+      diversityPlot = new ScatterPlot("Mutation Diversity", null);
+      diversityPlot.VisualProperties.XAxisTitle = "Solution Index";
+      diversityPlot.VisualProperties.YAxisTitle = "Diversity";
+    }
   }
 }
Index: /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/VariableDuplicator.cs
===================================================================
--- /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/VariableDuplicator.cs	(revision 8410)
+++ /branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/VariableDuplicator.cs	(revision 8410)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("VariableDuplicator", "An operator that duplicates variables.")]
+  [StorableClass]
+  public class VariableDuplicator : SingleSuccessorOperator {
+
+    #region Parameter properties
+    public ILookupParameter<IItem> OriginalParameter {
+      get { return (LookupParameter<IItem>)Parameters["Original"]; }
+    }
+    public ILookupParameter<IItem> CloneParameter {
+      get { return (LookupParameter<IItem>)Parameters["Clone"]; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private VariableDuplicator(bool deserializing) : base(deserializing) { }
+    private VariableDuplicator(VariableDuplicator original, Cloner cloner) : base(original, cloner) { }
+    public VariableDuplicator()
+      : base() {
+      Parameters.Add(new LookupParameter<IItem>("Original", "The orginal."));
+      OriginalParameter.ActualName = "TSPTour";
+
+      Parameters.Add(new LookupParameter<IItem>("Clone", "The clone."));
+      CloneParameter.ActualName = "TSPTourClone";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new VariableDuplicator(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      CloneParameter.ActualValue = (IItem)OriginalParameter.ActualValue.Clone();
+      return base.Apply();
+    }
+  }
+}